<?php

namespace Drupal\search_api_decoupled_facets\Plugin\facets\widget;

use Drupal\Core\Form\FormStateInterface;
use Drupal\facets\FacetInterface;
use Drupal\facets\Plugin\facets\widget\LinksWidget as BaseLinksWidget;

/**
 * Extend LinksWidget with orientation.
 */
class LinksWidget extends BaseLinksWidget {

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration() {
    return [
      'orientation' => 'horizontal',
    ] + parent::defaultConfiguration();
  }

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state, FacetInterface $facet) {
    $form = parent::buildConfigurationForm($form, $form_state, $facet);
    $options = [
      'horizontal' => $this->t('Horizontal'),
      'vertical' => $this->t('Vertical'),
    ];
    $form['orientation'] = [
      '#type' => 'select',
      '#title' => $this->t('Orientation'),
      '#default_value' => $this->getConfiguration()['orientation'],
      '#options' => $options,
      '#description' => $this->t('Orientation of the items.'),
      '#weight' => -10,
    ];
    return $form;
  }

}
