<?php

namespace Drupal\search_api_decoupled_ui;

use Drupal\Core\Form\FormStateInterface;
use Drupal\search_api_decoupled_ui\Plugin\search_ui_element\SearchUiElementBase;

/**
 * Abstract class providing validation and submit methods.
 */
abstract class ConfigurableSearchUiElementBase extends SearchUiElementBase implements ConfigurableSearchUiElementInterface {

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration() {
    return [
      'show_loading' => FALSE,
      'custom_element' => '',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form['show_loading'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Show loading message'),
      '#default_value' => $this->configuration['show_loading'],
    ];
    // Add custom element settings.
    $form['custom_element'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Custom element'),
      '#description' => $this->t('The web-component tag name. Use it when you want to use your own implementation of the element.'),
      '#default_value' => $this->configuration['custom_element'],
    ];
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateConfigurationForm(array &$form, FormStateInterface $form_state) {
  }

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $this->configuration['show_loading'] = (bool) $form_state->getValue('show_loading');
    $this->configuration['custom_element'] = $form_state->getValue('custom_element');
  }

}
